// This file generated by libqtelegram-code-generator.
// You can download it from: https://github.com/Aseman-Land/libqtelegram-code-generator
// DO NOT EDIT THIS FILE BY HAND -- YOUR CHANGES WILL BE OVERWRITTEN

#ifndef LQTG_TYPE_CONTACTSLINK
#define LQTG_TYPE_CONTACTSLINK

#include "telegramtypeobject.h"

#include <QMetaType>
#include <QVariant>
#include "core/inboundpkt.h"
#include "core/outboundpkt.h"
#include "../coretypes.h"

#include <QDataStream>

#include "contactlink.h"
#include "user.h"

class LIBQTELEGRAMSHARED_EXPORT ContactsLink : public TelegramTypeObject
{
public:
    enum ContactsLinkClassType {
        typeContactsLink = 0x3ace484c
    };

    ContactsLink(ContactsLinkClassType classType = typeContactsLink, InboundPkt *in = 0);
    ContactsLink(InboundPkt *in);
    ContactsLink(const Null&);
    virtual ~ContactsLink();

    void setForeignLink(const ContactLink &foreignLink);
    ContactLink foreignLink() const;

    void setMyLink(const ContactLink &myLink);
    ContactLink myLink() const;

    void setUser(const User &user);
    User user() const;

    void setClassType(ContactsLinkClassType classType);
    ContactsLinkClassType classType() const;

    bool fetch(InboundPkt *in);
    bool push(OutboundPkt *out) const;

    QMap<QString, QVariant> toMap() const;
    static ContactsLink fromMap(const QMap<QString, QVariant> &map);

    bool operator ==(const ContactsLink &b) const;

    bool operator==(bool stt) const { return isNull() != stt; }
    bool operator!=(bool stt) const { return !operator ==(stt); }

    QByteArray getHash(QCryptographicHash::Algorithm alg = QCryptographicHash::Md5) const;

private:
    ContactLink m_foreignLink;
    ContactLink m_myLink;
    User m_user;
    ContactsLinkClassType m_classType;
};

Q_DECLARE_METATYPE(ContactsLink)

QDataStream LIBQTELEGRAMSHARED_EXPORT &operator<<(QDataStream &stream, const ContactsLink &item);
QDataStream LIBQTELEGRAMSHARED_EXPORT &operator>>(QDataStream &stream, ContactsLink &item);

inline ContactsLink::ContactsLink(ContactsLinkClassType classType, InboundPkt *in) :
    m_classType(classType)
{
    if(in) fetch(in);
}

inline ContactsLink::ContactsLink(InboundPkt *in) :
    m_classType(typeContactsLink)
{
    fetch(in);
}

inline ContactsLink::ContactsLink(const Null &null) :
    TelegramTypeObject(null),
    m_classType(typeContactsLink)
{
}

inline ContactsLink::~ContactsLink() {
}

inline void ContactsLink::setForeignLink(const ContactLink &foreignLink) {
    m_foreignLink = foreignLink;
}

inline ContactLink ContactsLink::foreignLink() const {
    return m_foreignLink;
}

inline void ContactsLink::setMyLink(const ContactLink &myLink) {
    m_myLink = myLink;
}

inline ContactLink ContactsLink::myLink() const {
    return m_myLink;
}

inline void ContactsLink::setUser(const User &user) {
    m_user = user;
}

inline User ContactsLink::user() const {
    return m_user;
}

inline bool ContactsLink::operator ==(const ContactsLink &b) const {
    return m_classType == b.m_classType &&
           m_foreignLink == b.m_foreignLink &&
           m_myLink == b.m_myLink &&
           m_user == b.m_user;
}

inline void ContactsLink::setClassType(ContactsLink::ContactsLinkClassType classType) {
    m_classType = classType;
}

inline ContactsLink::ContactsLinkClassType ContactsLink::classType() const {
    return m_classType;
}

inline bool ContactsLink::fetch(InboundPkt *in) {
    LQTG_FETCH_LOG;
    int x = in->fetchInt();
    switch(x) {
    case typeContactsLink: {
        m_myLink.fetch(in);
        m_foreignLink.fetch(in);
        m_user.fetch(in);
        m_classType = static_cast<ContactsLinkClassType>(x);
        return true;
    }
        break;
    
    default:
        LQTG_FETCH_ASSERT;
        return false;
    }
}

inline bool ContactsLink::push(OutboundPkt *out) const {
    out->appendInt(m_classType);
    switch(m_classType) {
    case typeContactsLink: {
        m_myLink.push(out);
        m_foreignLink.push(out);
        m_user.push(out);
        return true;
    }
        break;
    
    default:
        return false;
    }
}

inline QMap<QString, QVariant> ContactsLink::toMap() const {
    QMap<QString, QVariant> result;
    switch(static_cast<int>(m_classType)) {
    case typeContactsLink: {
        result["classType"] = "ContactsLink::typeContactsLink";
        result["myLink"] = m_myLink.toMap();
        result["foreignLink"] = m_foreignLink.toMap();
        result["user"] = m_user.toMap();
        return result;
    }
        break;
    
    default:
        return result;
    }
}

inline ContactsLink ContactsLink::fromMap(const QMap<QString, QVariant> &map) {
    ContactsLink result;
    if(map.value("classType").toString() == "ContactsLink::typeContactsLink") {
        result.setClassType(typeContactsLink);
        result.setMyLink( ContactLink::fromMap(map.value("myLink").toMap()) );
        result.setForeignLink( ContactLink::fromMap(map.value("foreignLink").toMap()) );
        result.setUser( User::fromMap(map.value("user").toMap()) );
        return result;
    }
    return result;
}

inline QByteArray ContactsLink::getHash(QCryptographicHash::Algorithm alg) const {
    QByteArray data;
    QDataStream str(&data, QIODevice::WriteOnly);
    str << *this;
    return QCryptographicHash::hash(data, alg);
}

inline QDataStream &operator<<(QDataStream &stream, const ContactsLink &item) {
    stream << static_cast<uint>(item.classType());
    switch(item.classType()) {
    case ContactsLink::typeContactsLink:
        stream << item.myLink();
        stream << item.foreignLink();
        stream << item.user();
        break;
    }
    return stream;
}

inline QDataStream &operator>>(QDataStream &stream, ContactsLink &item) {
    uint type = 0;
    stream >> type;
    item.setClassType(static_cast<ContactsLink::ContactsLinkClassType>(type));
    switch(type) {
    case ContactsLink::typeContactsLink: {
        ContactLink m_my_link;
        stream >> m_my_link;
        item.setMyLink(m_my_link);
        ContactLink m_foreign_link;
        stream >> m_foreign_link;
        item.setForeignLink(m_foreign_link);
        User m_user;
        stream >> m_user;
        item.setUser(m_user);
    }
        break;
    }
    return stream;
}


#endif // LQTG_TYPE_CONTACTSLINK
