// This file generated by libqtelegram-code-generator.
// You can download it from: https://github.com/Aseman-Land/libqtelegram-code-generator
// DO NOT EDIT THIS FILE BY HAND -- YOUR CHANGES WILL BE OVERWRITTEN

#ifndef LQTG_TYPE_INPUTCHANNEL
#define LQTG_TYPE_INPUTCHANNEL

#include "telegramtypeobject.h"

#include <QMetaType>
#include <QVariant>
#include "core/inboundpkt.h"
#include "core/outboundpkt.h"
#include "../coretypes.h"

#include <QDataStream>

#include <QtGlobal>

class LIBQTELEGRAMSHARED_EXPORT InputChannel : public TelegramTypeObject
{
public:
    enum InputChannelClassType {
        typeInputChannelEmpty = 0xee8c1e86,
        typeInputChannel = 0xafeb712e
    };

    InputChannel(InputChannelClassType classType = typeInputChannelEmpty, InboundPkt *in = 0);
    InputChannel(InboundPkt *in);
    InputChannel(const Null&);
    virtual ~InputChannel();

    void setAccessHash(qint64 accessHash);
    qint64 accessHash() const;

    void setChannelId(qint32 channelId);
    qint32 channelId() const;

    void setClassType(InputChannelClassType classType);
    InputChannelClassType classType() const;

    bool fetch(InboundPkt *in);
    bool push(OutboundPkt *out) const;

    QMap<QString, QVariant> toMap() const;
    static InputChannel fromMap(const QMap<QString, QVariant> &map);

    bool operator ==(const InputChannel &b) const;

    bool operator==(bool stt) const { return isNull() != stt; }
    bool operator!=(bool stt) const { return !operator ==(stt); }

    QByteArray getHash(QCryptographicHash::Algorithm alg = QCryptographicHash::Md5) const;

private:
    qint64 m_accessHash;
    qint32 m_channelId;
    InputChannelClassType m_classType;
};

Q_DECLARE_METATYPE(InputChannel)

QDataStream LIBQTELEGRAMSHARED_EXPORT &operator<<(QDataStream &stream, const InputChannel &item);
QDataStream LIBQTELEGRAMSHARED_EXPORT &operator>>(QDataStream &stream, InputChannel &item);

inline InputChannel::InputChannel(InputChannelClassType classType, InboundPkt *in) :
    m_accessHash(0),
    m_channelId(0),
    m_classType(classType)
{
    if(in) fetch(in);
}

inline InputChannel::InputChannel(InboundPkt *in) :
    m_accessHash(0),
    m_channelId(0),
    m_classType(typeInputChannelEmpty)
{
    fetch(in);
}

inline InputChannel::InputChannel(const Null &null) :
    TelegramTypeObject(null),
    m_accessHash(0),
    m_channelId(0),
    m_classType(typeInputChannelEmpty)
{
}

inline InputChannel::~InputChannel() {
}

inline void InputChannel::setAccessHash(qint64 accessHash) {
    m_accessHash = accessHash;
}

inline qint64 InputChannel::accessHash() const {
    return m_accessHash;
}

inline void InputChannel::setChannelId(qint32 channelId) {
    m_channelId = channelId;
}

inline qint32 InputChannel::channelId() const {
    return m_channelId;
}

inline bool InputChannel::operator ==(const InputChannel &b) const {
    return m_classType == b.m_classType &&
           m_accessHash == b.m_accessHash &&
           m_channelId == b.m_channelId;
}

inline void InputChannel::setClassType(InputChannel::InputChannelClassType classType) {
    m_classType = classType;
}

inline InputChannel::InputChannelClassType InputChannel::classType() const {
    return m_classType;
}

inline bool InputChannel::fetch(InboundPkt *in) {
    LQTG_FETCH_LOG;
    int x = in->fetchInt();
    switch(x) {
    case typeInputChannelEmpty: {
        m_classType = static_cast<InputChannelClassType>(x);
        return true;
    }
        break;
    
    case typeInputChannel: {
        m_channelId = in->fetchInt();
        m_accessHash = in->fetchLong();
        m_classType = static_cast<InputChannelClassType>(x);
        return true;
    }
        break;
    
    default:
        LQTG_FETCH_ASSERT;
        return false;
    }
}

inline bool InputChannel::push(OutboundPkt *out) const {
    out->appendInt(m_classType);
    switch(m_classType) {
    case typeInputChannelEmpty: {
        return true;
    }
        break;
    
    case typeInputChannel: {
        out->appendInt(m_channelId);
        out->appendLong(m_accessHash);
        return true;
    }
        break;
    
    default:
        return false;
    }
}

inline QMap<QString, QVariant> InputChannel::toMap() const {
    QMap<QString, QVariant> result;
    switch(static_cast<int>(m_classType)) {
    case typeInputChannelEmpty: {
        result["classType"] = "InputChannel::typeInputChannelEmpty";
        return result;
    }
        break;
    
    case typeInputChannel: {
        result["classType"] = "InputChannel::typeInputChannel";
        result["channelId"] = QVariant::fromValue<qint32>(channelId());
        result["accessHash"] = QVariant::fromValue<qint64>(accessHash());
        return result;
    }
        break;
    
    default:
        return result;
    }
}

inline InputChannel InputChannel::fromMap(const QMap<QString, QVariant> &map) {
    InputChannel result;
    if(map.value("classType").toString() == "InputChannel::typeInputChannelEmpty") {
        result.setClassType(typeInputChannelEmpty);
        return result;
    }
    if(map.value("classType").toString() == "InputChannel::typeInputChannel") {
        result.setClassType(typeInputChannel);
        result.setChannelId( map.value("channelId").value<qint32>() );
        result.setAccessHash( map.value("accessHash").value<qint64>() );
        return result;
    }
    return result;
}

inline QByteArray InputChannel::getHash(QCryptographicHash::Algorithm alg) const {
    QByteArray data;
    QDataStream str(&data, QIODevice::WriteOnly);
    str << *this;
    return QCryptographicHash::hash(data, alg);
}

inline QDataStream &operator<<(QDataStream &stream, const InputChannel &item) {
    stream << static_cast<uint>(item.classType());
    switch(item.classType()) {
    case InputChannel::typeInputChannelEmpty:
        
        break;
    case InputChannel::typeInputChannel:
        stream << item.channelId();
        stream << item.accessHash();
        break;
    }
    return stream;
}

inline QDataStream &operator>>(QDataStream &stream, InputChannel &item) {
    uint type = 0;
    stream >> type;
    item.setClassType(static_cast<InputChannel::InputChannelClassType>(type));
    switch(type) {
    case InputChannel::typeInputChannelEmpty: {
        
    }
        break;
    case InputChannel::typeInputChannel: {
        qint32 m_channel_id;
        stream >> m_channel_id;
        item.setChannelId(m_channel_id);
        qint64 m_access_hash;
        stream >> m_access_hash;
        item.setAccessHash(m_access_hash);
    }
        break;
    }
    return stream;
}


#endif // LQTG_TYPE_INPUTCHANNEL
